/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTActiveConnector_h__
#define __RTActiveConnector_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTLayerConnector_h__
#include <RTLayerConnector.h>
#endif

class RTConnector_Actor;

class RTActiveConnector : public RTLayerConnector
{
public:
    explicit              RTActiveConnector( RTConnector_Actor * );
    virtual               ~RTActiveConnector( void );

    virtual RTLayerData * _registerSAP( RTController *,
					RTProtocol   *,
					const char   * );

    virtual RTLayerData * _registerSPP( RTController *,
					RTProtocol   *,
					const char   * );

    virtual void          _enumerate( void ) const;

private:
    RTConnector_Actor * connector;

    // unavailable methods
    RTActiveConnector( const RTActiveConnector & );
    RTActiveConnector & operator=( const RTActiveConnector & );
}; //lint !e1712

#endif // __RTActiveConnector_h__
