/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTActorId_h__
#define __RTActorId_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

class RTActor;
class RTActorRef;

class RTActorId : public RTDataObject
{
private:
    RTActor           * a;

public:
			RTActorId( const RTActor * = 0 ); //lint !e1931
			RTActorId( const RTActorId & );
    virtual             ~RTActorId( void );

			operator RTActor *( void ) const;
    RTActorId         & operator=( const RTActor * );
    RTActorId         & operator=( const RTActorId & );
    RTActor           * operator->( void ) const;

    virtual int         operator==( const RTDataObject & ) const;
    int                 operator==( const RTActorRef   & ) const;
    int                 operator==( const RTActorId    & ) const;

    RTS_INLINE int      operator!=( const RTDataObject & ) const;
    RTS_INLINE int      operator!=( const RTActorRef   & ) const;
    RTS_INLINE int      operator!=( const RTActorId    & ) const;

    int                 isValid( void ) const;
    RTActor           * getRTActor( void ) const;
    void                resetActor( void );

    virtual const RTObject_class * getClassData( void ) const;
    static  const RTObject_class   classData;

#define RTType_RTActorId ( RTActorId::classData )
};

struct RTTypedValue_RTActorId
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTActorId( const RTActorId      & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTActorId( const RTActorId      &,
				       const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTActorId.inl>
#endif

#endif // __RTActorId_h__
