/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTBindingDescriptor_h__
#define __RTBindingDescriptor_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

struct RTProtocolDescriptor;

// This structure describes one of the protocol requirements placed on
// a component of an actor class because of a binding involving that
// component. The field 'relay' is a zero-based value that identifies
// the interface of the component used by the binding; the order of
// interfaces is defined by the default class for the component.
// The field 'protocol' refers to the protocol that is bound to that
// interface.

struct RTBindingDescriptor
{
    int                          relay;
    const RTProtocolDescriptor * protocol;
};

#endif // __RTBindingDescriptor_h__
