/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTCachedString_inl__
#define __RTCachedString_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTCachedString_h__
#include <RTCachedString.h>
#endif

#ifndef __RTMemoryUtil_h__
#include <RTMemoryUtil.h>
#endif

RTS_INLINE RTCachedString::RTCachedString( void )
    : _entry( (Entry *)0 )
{
}

RTS_INLINE RTCachedString::operator const char *( void ) const
{
    return ( _entry != (Entry *)0 ) ? _entry->value
				    : (char *)0;
}

RTS_INLINE int RTCachedString::operator==( const char * string ) const
{
    return string != (const char *)0
	&& _entry != (Entry      *)0
	&& RTMemoryUtil::strcmp( _entry->value, string ) == 0;
}

RTS_INLINE int RTCachedString::operator!=( const char * string ) const
{
    return operator==( string ) == 0;
}

RTS_INLINE int RTCachedString::operator==( const RTCachedString & rhs ) const
{
    return operator==( rhs.operator const char *() );
}

RTS_INLINE int RTCachedString::operator!=( const RTCachedString & rhs ) const
{
    return operator!=( rhs.operator const char *() );
}

#endif // __RTCachedString_inl__
