/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTDictionary_inl__
#define __RTDictionary_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDictionary_h__
#include <RTDictionary.h>
#endif

RTS_INLINE unsigned RTDictionary::size( void ) const
{
    return _used;
}

RTS_INLINE int RTDictionary::add( const RTAssociation & assoc )
{
    return atPut( assoc.key, assoc.value );
}

RTS_INLINE RTDictionary::Iterator::Iterator( void )
    : _index( 0 )
{
}

RTS_INLINE RTDictionary::Iterator::~Iterator( void )
{
}

RTS_INLINE void RTDictionary::Iterator::reset( void )
{
    _index = 0;
}

#endif // __RTDictionary_inl__
