/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTEnumerated_h__
#define __RTEnumerated_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

class RTEnumerated : public RTDataObject
{
public:
    int                     value;

    virtual                 ~RTEnumerated( void );

    RTS_INLINE              operator int( void ) const;
    virtual int             operator==( const RTDataObject & ) const;

    virtual int             lower( void ) const;
    virtual int             upper( void ) const = 0;

    virtual const RTObject_class * getClassData( void ) const = 0;
    static  const RTObject_class   classData;

#define RTType_RTEnumerated ( RTEnumerated::classData )

protected:
    explicit                RTEnumerated( int );
			    RTEnumerated( const RTEnumerated & );
			    RTEnumerated & operator=( const RTEnumerated & );
}; //lint !e1712

struct RTTypedValue_RTEnumerated
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTEnumerated( const RTEnumerated & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTEnumerated( const RTEnumerated   &,
					  const RTObject_class * );
}; //lint !e1712

// Subclasses will refer to these functions in their classData.
#if OBJECT_DECODE
    extern int RTEnumerated_decode( const RTObject_class *,
				    void                 *,
				    RTDecoding           * );
#endif
#if OBJECT_ENCODE
    extern int RTEnumerated_encode( const RTObject_class *,
				    const void           *,
				    RTEncoding           * );
#endif

#if RTS_INLINES
#include <RTEnumerated.inl>
#endif

#endif // __RTEnumerated_h__
