/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTInterfaceDescriptor_h__
#define __RTInterfaceDescriptor_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

// This structure describes the replication requirements of a single
// interface of a component of an actor class. These are organized into
// arrays indexed in same way as relay ports. If an interface is unused,
// the corresponding entry in the array should specify a replication of
// zero. The array may be truncated to exclude trailing descriptors
// specifying replication factor zero.

struct RTInterfaceDescriptor
{
    const char * name;
    int          replication;
};

#endif // __RTInterfaceDescriptor_h__
