/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTRootProtocol_h__
#define __RTRootProtocol_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTGlobalSignal_h__
#include <RTGlobalSignal.h>
#endif

#ifndef __RTInSignal_h__
#include <RTInSignal.h>
#endif

#ifndef __RTProtocol_h__
#include <RTProtocol.h>
#endif

class RTRootProtocol : public RTProtocol
{
public:
    RTS_INLINE RTRootProtocol( void );
    RTS_INLINE ~RTRootProtocol( void );

    static const RTProtocolDescriptor rt_class;

    enum // "in" signals
    {
	rti_rtBound   = rtiLast_RTProtocol + 1
      , rti_rtUnbound
    };

    RTS_INLINE RTInSignal rtBound( void );
    RTS_INLINE RTInSignal rtUnbound( void );

protected:
    enum
    {
	rtiLast_RTRootProtocol = rti_rtUnbound
    };

private:
    // unavailable methods
    RTRootProtocol( const RTRootProtocol & );
    RTRootProtocol & operator=( const RTRootProtocol & );
}; //lint !e1712

#if RTS_INLINES
#include <RTRootProtocol.inl>
#endif

#endif // __RTRootProtocol_h__
