/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTSignalDescriptor_h__
#define __RTSignalDescriptor_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

struct RTObject_class;

// This structure describes a signal of a protocol.
//
// Field    Meaning
// -----    -------
// name     The name of the signal.
// type     The type associated with the signal.
// value    The internal representation of the signal.

struct RTSignalDescriptor
{
    const char           * name;
    const RTObject_class * type;
    int                    value;
};

#endif // __RTSignalDescriptor_h__
