/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTTimerId_h__
#define __RTTimerId_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTFieldDescriptor_h__
#include <RTFieldDescriptor.h>
#endif

#ifndef __RTObject_class_h__
#include <RTObject_class.h>
#endif

class RTController;
class RTTimerNode;

class RTTimerId
{
public:
    RTS_INLINE      RTTimerId( void );
    RTS_INLINE      RTTimerId( RTTimerNode * ); //lint !e1931
    RTS_INLINE      RTTimerId( const RTTimerId & );
		    ~RTTimerId( void );

    RTTimerId     & operator=( const RTTimerId & );
    RTTimerId     & operator=( RTTimerNode * );

    RTS_INLINE int  operator==( const RTTimerId & ) const;
    RTS_INLINE int  operator!=( const RTTimerId & ) const;

    RTS_INLINE int  isValid( void ) const;
    int             timeouts( void ) const;

    static const RTObject_class classData;

#define RTType_RTTimerId ( RTTimerId::classData )

private:
    friend class RTTimerNode;

    static const RTFieldDescriptor fieldData[];

    struct Ring
    {
	RTS_INLINE  Ring( void );

	Ring      * prev;
	Ring      * next;
    };

    Ring            ring;
    RTTimerNode   * node;
};

struct RTTypedValue_RTTimerId
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTTimerId( const RTTimerId      & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTTimerId( const RTTimerId      &,
				       const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTTimerId.inl>
#endif

#endif // __RTTimerId_h__
