/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActorId.h>
#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTnew.h>

static RTDataObject * _access( RTActorId * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTActorId;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const RTActorId      * source )
{
    (void)new( target ) RTActorId( *source );
}

#if OBJECT_DECODE
static int _decode( const RTObject_class *,
		    RTActorId            * target,
		    RTDecoding           * coding )
{
    void * address;

    if( coding->get_address( address ) == 0 )
	return 0;

    *target = (RTActor *)address;

    return 1;
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *,
		    const RTActorId      * source,
		    RTEncoding           * coding )
{
    return coding->put_address( source->getRTActor() );
}
#endif

static const RTFieldDescriptor _fields[] =
{
    {
	"RTActorId",
	(RTFieldOffset)0,
	&RTActorId::classData,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTActorId::classData =
{
    &RTType_RTDataObject,
    (RTSuperAccessFunction)_access,
    "RTActorId",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTActorId ),
    _init,
    (RTCopyFunction)_copy,
#if OBJECT_DECODE
    (RTDecodeFunction)&_decode,
#endif
#if OBJECT_ENCODE
    (RTEncodeFunction)_encode,
#endif
    RTDataObject_destroy,
    1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTActorId_installer( RTType_RTActorId );
#endif

const RTObject_class * RTActorId::getClassData( void ) const
{
    return &RTActorId::classData;
}
