/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorProbe.h>
#include <RTActorRef.h>
#include <RTActor_class.h>
#include <RTComponentDescriptor.h>
#include <RTDebugger.h>

void RTActorProbe::evtReference( int compIndex, int observerId )
{
    if( _actor == (RTActor *)0 )
	return;

    const RTActor_class * info = _actor->getActorData();

    if( compIndex >= info->numComponents )
	return;

    int beginVal = ( compIndex >= 0 ? compIndex     : 0 );
    int endVal   = ( compIndex >= 0 ? compIndex + 1 : info->numComponents );

    for( int iComp = beginVal; iComp < endVal; ++iComp )
    {
	const RTComponentDescriptor * desc = &info->components[ iComp ];

	RTActorRef * actorRef = RTObjectOf( RTActorRef, desc->offset, _actor );

	int nrIncarns = 0;
	for( int iIncarn = 0; iIncarn < desc->replication; ++iIncarn )
	    if( (*actorRef)[ iIncarn ] != (RTActor *)0 )
		++nrIncarns;

	(void)_debugger->evtReference( _id, _actor, iComp,
				       nrIncarns, observerId );
    }
}
