/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiDecoding.h>
#include <RTFieldDescriptor.h>
#include <RTFieldOffset.h>
#include <RTObject_class.h>

int RTAsciiDecoding::get_array( void                 * target,
				int                    size,
				const RTObject_class * element )
{
    if( size > 0 )
    {
	const RTFieldOffset stride = element->_size;

	for(;;)
	{
	    if( element->decode( target, this ) == 0 )
		return 0;

	    if( --size == 0 )
		break;

	    if( getFieldSeparator() == 0 )
		return 0;

	    target = RTObjectOf( void, stride, target );
	}
    }

    return 1;
}
