/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTTimerNode.h>

void RTController::freeTimerNode( RTTimerNode * node )
{
    node->clear();

#if PURIFY
    delete node;
#else

#if USE_THREADS
    _mutex->enter();
#endif

    enum
    {
	minFreeListSize =  20,
	maxFreeListSize = 100
    };

    node->next = freeTimerList;
    freeTimerList = node;

    if( ++freeTimerListSize > (unsigned)maxFreeListSize )
    {
	while( freeTimerListSize > (unsigned)minFreeListSize )
	{
	    node = freeTimerList->next;
	    delete freeTimerList;
	    freeTimerList = node;
	    --freeTimerListSize;
	}
    }

#if USE_THREADS
    _mutex->leave();
#endif

#endif // PURIFY
}
