/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDataObject.h>
#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>
#include <RTnew.h>

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTDataObject;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTDataObject( *(const RTDataObject *)source );
}

#if OBJECT_DECODE
static int _decode( const RTObject_class *, void *, RTDecoding * )
{
    return 1; // this must be a null object
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *, const void *, RTEncoding * )
{
    return 1;
}
#endif

const RTObject_class RTDataObject::classData =
{
    (const RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "Null",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTDataObject ),
    _init,
    _copy,
#if OBJECT_DECODE
    _decode,
#endif
#if OBJECT_ENCODE
    _encode,
#endif
    RTDataObject_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller RTDataObject_installer( RTType_RTDataObject );
#endif

const RTObject_class * RTDataObject::getClassData( void ) const
{
    return &RTDataObject::classData;
}
