/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTActorRefProbe.h>
#include <RTDebugger.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTProbe.h>

void RTDebugger::actorIncarnated( RTActor * actor )
{
#if USE_THREADS
    _mutex->enter();
#endif

    RTProbe * probe;

    for( int i = 0; i < parkedProbes.size(); ++i )
    {
	if( (probe = (RTProbe *)parkedProbes[ i ]) != (RTProbe *)0 &&
	    probe->connectProbe() != 0 )
	{
	    parkedProbes[ i ] = (void *)0;
	    --nrParkedProbes;
	}
    }

    RTActorRef * homeRef = actor->getReference();

    if( homeRef != (RTActorRef *)0 && homeRef->probe != (RTActorRefProbe *)0 )
	homeRef->probe->evtPresence( actor->getIndex(), -1, -1 );

#if USE_THREADS
    _mutex->leave();
#endif
}
