/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebugger.h>
#include <RTMain.h>
#include <RTMemoryUtil.h>

void RTDebugger::debugIt( const char * cmdLine )
{
    if( phase() < RTJob::running )
    {
	enter( RTJob::running );

#if OBSERVABLE
	checkObservability();
#endif

	int                  argc = RTMain::argCount();
	const char * const * argv = RTMain::argStrings();
	const char         * init = (const char *)0;

	while( ++argv, --argc > 0 )
	    if( RTMemoryUtil::strcmp( *argv, "-URTS_DEBUG=", 12 ) == 0 )
		init = *argv + 12;

	if( init == (const char *)0 )
	    init = RTMemoryUtil::_getenv( "URTS_DEBUG" );

	if( init != (const char *)0 )
	{
	    input.pushInput( init );
	    doCmd();
	}
    }

    if( cmdLine != (const char *)0 )
	input.pushInput( cmdLine );
#if OBSERVABLE
    else if( mainObserverLoop() > 0 )
	return;
#endif

    if( phase() != RTJob::finished )
	doCmd();
}
