/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebugger.h>
#include <RTTimerActor.h>

static const RTTimespec oneNanoSecond( 0L, 1L );

void RTDebugger::getTimestamp( RTTimespec & ts )
{
    RTTimerActor::getRelativeClock( ts );

    // Some platforms can give consecutive timestamps with
    // the same value. Avoid that by adding a nanosecond.
    //
    if( ts <= lastTimestamp ) //lint !e909
    {
	lastTimestamp += oneNanoSecond;
	ts = lastTimestamp;
    }
    else
	lastTimestamp = ts;

    ts -= zeroTimeBase;
}
