/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebugger.h>
#include <RTDiag.h>
#include <RTDiagStream.h>

static const char * const help_text[] =
{
    "    attach <taskId>  Pay attention to <taskId>.\n",
    "    detach <taskId>  Don't pay attention to <taskId>.\n",
    "    exit             Terminate process.\n",
    "    go [<n>]         Deliver <n> (default: 10) messages.\n",
    "    help             Print help information.\n",
    "    info <actor>     Show information about <actor>.\n",
    "    log <category> <detail-level>\n",
    "                     Log ROOM primitives.\n",
    "        <category>:     communication exception frame layer timer system all\n",
    "        <detail-level>: none errors all\n",
    "    printstats <n>   Print current statistics for task <n>.\n",
    "    quit             Quit debug mode.\n",
    "    saps             Show registered SPPs and corresponding SAPs.\n",
    "    stats <n>        Alias for printstats.\n",
    "    step [<n>]       Deliver <n> (default: 1) messages.\n",
    "    system [<actor> [<depth>]]\n",
    "                     List all the active actors in the system,\n",
    "                     starting with <actor> (default: 1 = the top actor)\n",
    "                     and <depth> (default: 0 = all) levels down.\n",
    "    tasks            Print list of tasks.\n",
    "\n",
    "  Unambiguous abbreviations are permitted for all commands.\n",
    (const char *)0
};

void RTDebugger::printHelp( void )
{
    RTDiag::out() << help_text;
}
