/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebuggerInput.h>
#include <RTDiag.h>
#include <RTDiagStream.h>

int RTDebuggerInput::getChar( void )
{
    int c;

    if( unget_size > 0 )
	c = (int)unget_buffer[ --unget_size ];
    else if( input != (const char *)0 )
    {
	if( *input == '\0' )
	{
	    input = (const char *)0;
	    c = '\n';
	}
	else
	    c = *input++;
    }
    else
    {
	if( need_prompt != 0 && prompt != (const char *)0 )
	{
	    RTDiagStream & out = RTDiag::out();

	    out << prompt;
	    out.flush();
	}
	need_prompt = 0;

	c = nextChar();

	if( c == '\n' )
	    need_prompt = 1;
    }

    return c;
}
