/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTArray_class.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>

static void array_copy( void                 * target,
			const void           * source,
			const RTObject_class * element,
			int                    size,
			int                    indirect )
{
    RTArray_class array( size, element );

    if( indirect == 0 )
	array.copy( target, source );
    else
    {
	void * target_array = array.allocate();

	if( target_array != (void *)0 )
	    array.copy( target_array, *(const void * const *)source );

	*(void **)target = target_array;
    }
}

void RTFieldDescriptor::copy( void * target, const void * source ) const
{
    void       * target_field = RTObjectOf     ( void, offset, target );
    const void * source_field = RTConstObjectOf( void, offset, source );

    if( modifier == (const RTTypeModifier *)0 )
	type->copy( target_field, source_field );
    else
	array_copy( target_field, source_field,
		    type, (*modifier->_num_elements_func)( modifier, source ),
		    modifier->_indirect );
}
