/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActorRef.h>
#include <RTController.h>
#include <RTFrame.h>

int Frame::Base::destroy( RTActorRef & reference )
{
    RTController * controller = context();

    controller->trace( RTController::FrameDestroy, &reference,
						   (const void *)0 );

#if RTFRAME_CHECKING != RTFRAME_CHECK_NONE
    if( permissionCheck( RTController::FrameDestroy, &reference, 0 ) == 0 )
	return 0; // not allowed
#endif

    if( reference.isOptional() == 0 )
    {
	controller->setError( RTController::notOptional,
			      RTController::FrameDestroy, &reference,
							  (const void *)0 );
	return 0;
    }

    return reference.destroy();
}
