/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActorRef.h>
#include <RTController.h>
#include <RTFrame.h>

int Frame::Base::import( RTActorRef & actor, RTActorRef & dest, int index )
{
#if RTFRAME_CHECKING != RTFRAME_CHECK_NONE
    if( permissionCheck( RTController::FrameImport, &dest, 1 ) == 0 )
	return 0; // not allowed
#endif

    if( actor.size() != 1 )
    {
	RTController * controller = context();

	controller->trace( RTController::FrameImport, &dest, &index );
	controller->setError( RTController::replRef,
			      RTController::FrameImport, &dest, &index );
	return 0;
    }

    return dest.import( actor[ 0 ], index );
}
