/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTIOMonitor.h>
#include <RTTimespec.h>

int RTIOMonitor::status( int fd )
{
    if( fd < 0 )
	return 0;

    unsigned lo = 0U;
    unsigned hi = _used;

    if( hi == 0U )
	return 0;

    (void)wait( &RTTimespec::zero );

    // Entries are sorted: do binary search.

    while( lo < hi )
    {
	unsigned   mid   = ( lo + hi ) >> 1;
	Entry    * entry = &_entries[ mid ];

	if( entry->fd == (unsigned)fd )
	    return entry->bits >> ResultShift; //lint !e702

	if( entry->fd > (unsigned)fd )
	    hi = mid;
	else
	    lo = mid + 1U;
    }

    return 0;
}
