/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTLayerConnector.h>
#include <RTProtocol.h>
#include <RTQueue.h>

int RTLayerConnector::install( RTController * context, const char * name )
{
    lock();

    int status = connectors.atPut( name, (void *)this );

    if( status != 0 )
    {
	RTQueue    * queue;
	void       * entry;
	RTProtocol * port;
	Pending    * pending;

	queue = (RTQueue *)(pendingSPPs[ name ]);

	if( queue != (RTQueue *)0 )
	{
	    // register pending SPPs
	    (void)pendingSPPs.remove( name );

	    RTQueue::Iterator iterator( *queue );

	    while( (entry = iterator.next()) != (void *)0 )
	    {
		pending      = (Pending *)entry;
		port         = pending->port;
		port->_layer = (RTLayerData *)0;
		port->_layer = _registerSPP( context, port, pending->name );

		delete pending;
	    }

	    delete queue;
	}

	queue = (RTQueue *)(pendingSAPs[ name ]);

	if( queue != (RTQueue *)0 )
	{
	    // register pending SAPs
	    (void)pendingSAPs.remove( name );

	    RTQueue::Iterator iterator( *queue );

	    while( (entry = iterator.next()) != (void *)0 )
	    {
		pending      = (Pending *)entry;
		port         = pending->port;
		port->_layer = (RTLayerData *)0;
		port->_layer = _registerSAP( context, port, pending->name );

		delete pending;
	    }

	    delete queue;
	}
    }

    unlock();

    return status;
}
