/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTDiagStream.h>
#include <RTLocalConnector.h>

void RTLocalConnector::_enumerate( void ) const
{
    RTDiagStream           & out   = RTDiag::out();
    int                      count = 0;
    RTDictionary::Iterator   iterator;
    const RTAssociation    * assoc;

    while( (assoc = db.iterate( iterator )) != (const RTAssociation *)0 )
    {
	if( count == 0 )
	    out << "  Name (SAPs,SPPs)\n";

	const SppNode * node = (const SppNode *)assoc->value;

	out << "    " << assoc->key
	    << " ( "  << node->sapTotal()
	    << ", "   << node->sppTotal()
	    << " )\n";

	++count;
    }

    if( count == 0 )
	out << "  Nothing registered.\n";
}
