/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void char_init( const RTObject_class *, void * target )
{
    *(char *)target = '\0';
}

static void char_copy( const RTObject_class *,
		       void                 * target,
		       const void           * source )
{
    *(char *)target = *(const char *)source;
}

#if OBJECT_DECODE
static int char_decode( const RTObject_class *,
			void                 * target,
			RTDecoding           * coding )
{
    return coding->get_char( *(char *)target );
}
#endif

#if OBJECT_ENCODE
static int char_encode( const RTObject_class *,
			const void           * source,
			RTEncoding           * coding )
{
    return coding->put_char( *(const char *)source );
}
#endif

const RTObject_class RTType_char =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "char",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( char ),
    char_init,
    char_copy,
#if OBJECT_DECODE
    char_decode,
#endif
#if OBJECT_ENCODE
    char_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller char_installer( RTType_char );
#endif
