/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDaemon.h>
#include <RTMemoryUtil.h>
#include <RTObserver.h>
#include <RTTcpSocket.h>

RTObserver::RTObserver( RTDebugger  * theDebugger,
			RTTcpSocket * theSocket,
			int           theObsId,
			const char  * initBuf,
			int           initLen )
    : debugger   (                    theDebugger )
    , socket     (                      theSocket )
    , observerId (                       theObsId )
    , daemon     (                  (RTDaemon *)0 )
    , daemons    (                                )
    , superDaemon(                  (RTDaemon *)0 )
    , bufSize    (                           2048 )
    , bufUsed    (                              0 )
    , inBuffer   ( new char [ (unsigned)bufSize ] )
    , haltByProbe(                              0 )
    , resumeToRun(                              0 )
    , lastFlowCmd(                       FlowNone )
{
    if( inBuffer != (char *)0 && initBuf != (const char *)0 )
    {
	if( (bufUsed = initLen) < 0 )
	    bufUsed = RTMemoryUtil::strlen( initBuf );

	if( bufUsed > bufSize )
	    bufUsed = bufSize;

	RTMemoryUtil::memcpy( inBuffer, initBuf, bufUsed );
    }

    cmdCreateDaemon( -1 ); // super daemon
    (void)setDaemon( -1 );
    daemon->updateSettings( "report=True" );
}
