/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDaemon.h>
#include <RTDaemonInfo.h>
#include <RTEventInfo.h>
#include <RTMessage.h>
#include <RTObserver.h>

// return -1 if no daemon was interested
//         0 if at least one daemon was interested
//       > 0 if at least one daemon wanted to halt

int RTObserver::prepareEvent( RTEventInfo & eventInfo )
{
    int shouldHalt   = 0;
    int shouldReport = 0;

    for( int daemonId = 0; daemonId < daemons.size(); ++daemonId )
    {
	RTDaemon * theDaemon = (RTDaemon *)daemons[ daemonId ];

	if( theDaemon == (RTDaemon *)0 )
	    continue;

	// update the daemon's settings
	if( eventInfo.eventKind == RTEventInfo::EventPresence )
	    theDaemon->setInfo( eventInfo );

	if( theDaemon->setting( eventInfo.eventKind ) == 0 )
	    continue;

	if( eventInfo.eventKind != RTEventInfo::EventControl &&
	    theDaemon->eventMatches( eventInfo ) == (RTDaemonInfo *)0 )
	{
	    continue;
	}

	shouldReport  = 1;
	shouldHalt   |= theDaemon->shouldHalt();
    }

    if( shouldReport != 0 && superDaemon->shouldReport() != 0 )
    {
	if( shouldHalt != 0 )
	    haltByProbe = 1;

	return shouldHalt;
    }

    return -1;
}
