/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTIOMonitor.h>
#include <RTMemoryUtil.h>
#include <RTTcpSocket.h>
#include <RTinet.h>

int RTTcpSocket::connect( const char * host, int port )
{
    if( _sd == INET_NO_SOCKET )
	return 0;

    if( lookup( host, _peer_ip ) == 0 )
	return 0;

    _peer_port = port;

    if( _monitor != (RTIOMonitor *)0 )
	_monitor->add( _sd, RTIOMonitor::CanRead  |
			    RTIOMonitor::CanWrite |
			    RTIOMonitor::Exception );

    if( try_connect() == 0 )
    {
	close();
	return 0;
    }

    if( _monitor != (RTIOMonitor *)0 && _state == Established )
	_monitor->remove( _sd, RTIOMonitor::CanWrite |
			       RTIOMonitor::Exception );

    return 1;
}
