/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTIOMonitor.h>
#include <RTTcpSocket.h>

int RTTcpSocket::hasData( void )
{
    int result;

    switch( state() )
    {
    case Closed:
	result = 1; // read to see EOF
	break;

    case SynSent:
	result = 0; // let connect complete before trying to read
	break;

#ifdef _lint
    case Listen:
    case Established:
#endif
    default:
	if( _monitor == (RTIOMonitor *)0 )
	{
	    RTIOMonitor monitor;

	    monitor.add( _sd, RTIOMonitor::CanRead );

	    result = ( monitor.status( _sd ) & RTIOMonitor::CanRead ) != 0;
	}
	else
	    result = ( _monitor->status( _sd ) & RTIOMonitor::CanRead ) != 0;
	break;
    }

    return result;
}
