/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTIOMonitor.h>
#include <RTMemoryUtil.h>
#include <RTTcpSocket.h>
#include <RTinet.h>
#include <RTtcp.h>

int RTTcpSocket::listen( int port )
{
    if( _sd == INET_NO_SOCKET )
	return 0;

    if( RTinet_bind( _sd, (const RTinet_address *)0, (RTinet_port)port ) == 0 )
	return 0;

    if( RTinet_listen( _sd ) == 0 )
	return 0;

    _state = Listen;

    if( _monitor != (RTIOMonitor *)0 )
	// incoming connections can be accepted when this socket is readable
	_monitor->add( _sd, RTIOMonitor::CanRead );

    return 1;
}
