/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTTimerActor.h>
#include <RTTimerNode.h>
#include <RTTimespec.h>

void RTTimerActor::sendTimeouts( void )
{
#if USE_THREADS
    RTTimerNode::critical.enter();
#endif

    RTController * controller = context();
    RTTimespec     now;

    RTTimespec::getclock( now );

    pendingAbsolute.expire( now, controller );

    // expireTime for relative time is adjusted by currentOffset

    now -= currentOffset;

    pendingRelative.expire( now, controller );

#if USE_THREADS
    RTTimerNode::critical.leave();
#endif
}
