/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFieldOffset.h>
#include <RTTimerNode.h>
#include <RTTiming.h>

void RTTimerNode::_disconnectAll( void )
{
    // remove this from the chain of node created by sap
    if( sap != (Timing::Base *)0 )
    {
	if( sap->outstanding == this )
	    sap->outstanding = ( next != this ) ? next
						: (RTTimerNode *)0;

	prev->next = next;
	next->prev = prev;

	prev = this;
	next = this;
    }

    // invalidate all RTTimerId objects that refer to this node
    const RTFieldOffset offset = RTOffsetOf( RTTimerId, ring );

    while( id_ring.next != &id_ring )
    {
	RTTimerId * id = RTObjectOf( RTTimerId, - offset, id_ring.next );

	id->node = (RTTimerNode *)0;

	id->ring.prev->next = id->ring.next;
	id->ring.next->prev = id->ring.prev;

	id->ring.prev = &id->ring;
	id->ring.next = &id->ring;
    }
}
