/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMessage.h>
#include <RTTimerNode.h>
#include <RTTiming.h>

void RTTimerNode::setValue( RTMessage            * _msg,
			    Timing::Base         * _sap,
			    const RTTimespec     & _expireTime,
			    const RTTimespec     & _repeatInterval,
			    const void           * _data,
			    const RTObject_class * _type,
			    int                    _priority )
{
    RTTimerNode * outstanding = _sap->outstanding;

    if( outstanding == (RTTimerNode *)0 )
    {
	prev              = this;
	outstanding       = this;
	_sap->outstanding = this;
    }

    prev = outstanding->prev;
    next = outstanding;

    outstanding->prev->next = this;
    outstanding->prev       = this;

    msg            = _msg;
    sap            = _sap;
    expireTime     = _expireTime;
    repeatInterval = _repeatInterval;

    if( _type == (const RTObject_class *)0 || _type == &RTType_void )
	data = RTConstCast( void, _data );
    else
    {
	data = _type->allocate();
	_type->copy( data, _data );
    }

    type = _type;

    buildMsg( msg, _sap->getOwner(), _priority );
}
