
/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTTime.h>
#include <RTTimespec.h>

RTTimespec::RTTimespec( const RTTime & other )
#ifdef _lint
    : tv_sec ( 0L )
    , tv_nsec( 0L )
#endif
{
    const long secsPerDay = 24L * 60L * 60L;

    getclock( *this );

    long cursec   = (long)tv_sec % secsPerDay;
    long secOfDay = (long)other.asInt();

    if( cursec < 0L ) //lint !e774
	cursec += secsPerDay;

    tv_sec += secOfDay - cursec;

    if( ( secOfDay  < cursec ) ||
	( secOfDay == cursec && tv_nsec != 0L ) ) //lint !e774 !e944
    {
	tv_sec += secsPerDay;
    }

    tv_nsec = 0L;
}
