/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTTimespec.h>

void RTTimespec::normalize( void )
{
    const long nsecs_per_sec = 1000000000L;

    for(;;)
    {
	if( tv_sec < 0L )
	{
	    if( - nsecs_per_sec < tv_nsec && tv_nsec <= 0L )
		break;

	    tv_sec  += tv_nsec / nsecs_per_sec;
	    tv_nsec %= nsecs_per_sec;

	    if( tv_nsec > 0L )
	    {
		tv_sec  += 1L;
		tv_nsec -= nsecs_per_sec;
	    }
	}
	else if( tv_sec > 0L )
	{
	    if( 0L <= tv_nsec && tv_nsec < nsecs_per_sec )
		break;

	    tv_sec  += tv_nsec / nsecs_per_sec;
	    tv_nsec %= nsecs_per_sec;

	    if( tv_nsec < 0L )
	    {
		tv_sec  -= 1L;
		tv_nsec += nsecs_per_sec;
	    }
	}
	else // tv_sec == 0
	{
	    if( - nsecs_per_sec < tv_nsec && tv_nsec < nsecs_per_sec )
		break;

	    tv_sec  += tv_nsec / nsecs_per_sec;
	    tv_nsec %= nsecs_per_sec;
	}
    }
}
