/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTInterval.h>
#include <RTTimespec.h>
#include <RTTiming.h>
#include <RTTypedValue.h>

RTTimerNode * Timing::Base::informIn( unsigned long        ticks,
				      const RTTypedValue & info,
				      int                  prio )
{
    RTInterval interval( ticks );
    RTTimespec delta( interval );

    return informIn( delta, info, prio );
}

RTTimerNode * Timing::Base::informIn( unsigned long ticks, int prio )
{
    RTTypedValue info( (const void *)0, (const RTObject_class *)0 );

    return informIn( ticks, info, prio );
}

RTTimerNode * Timing::Base::informIn( unsigned long        ticks,
				      const RTDataObject & data,
				      int                  prio )
{
    RTTypedValue info( (const void *)&data, data.getClassData() );

    return informIn( ticks, info, prio );
}
