/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifdef PRAGMA
#pragma implementation "RTUnknownObject.h"
#endif

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTFieldOffset.h>
#include <RTMemoryUtil.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>
#include <RTUnknownObject.h>

static void unknown_copy( const RTObject_class *,
			  void                 * _target,
			  const void           * _source )
{
    const RTUnknownObject * source = (const RTUnknownObject *)_source;
    RTUnknownObject       * target = (RTUnknownObject       *)_target;

    target->signature = RTMemoryUtil::strdup( source->signature );
    target->length    = source->length;
    target->code      = (char *)RTMemoryUtil::memdup( source->code,
						      source->length );
}

static void unknown_destroy( const RTObject_class *, void * target )
{
    RTUnknownObject * data = (RTUnknownObject *)target;

    delete [] data->signature;
    delete [] data->code;

    data->signature = (char *)0;
    data->length    = 0;
    data->code      = (char *)0;
}

int RTUnknownObject_length( const RTTypeModifier *, const void * source )
{
    const RTUnknownObject * data = (const RTUnknownObject *)source;

    return data->length;
}

static const RTTypeModifier coding_modifier =
{
    RTUnknownObject_length, 0, 1
};

static const RTFieldDescriptor _fields[] =
{
    {
	"signature",
	RTOffsetOf( RTUnknownObject, signature ),
	&RTType_RTpchar,
	(const RTTypeModifier *)0
    },
    {
	"length",
	RTOffsetOf( RTUnknownObject, length ),
	&RTType_int,
	(const RTTypeModifier *)0
    },
    {
	"code",
	RTOffsetOf( RTUnknownObject, code ),
	&RTType_char,
	&coding_modifier
    }
};

const RTObject_class RTUnknownObject::classData =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "RTUnknownObject",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTUnknownObject ),
    RTstruct_init,
    unknown_copy,
    RTstruct_decode,
#if OBJECT_ENCODE
    RTstruct_encode,
#endif
    unknown_destroy,
    3, _fields
};

RTTypeInstaller RTUnknownObject_installer( RTType_RTUnknownObject );
