/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMemoryUtil.h>
#include <RTTcpSocket.h>
#include <RTVersion.h>
#include <RTWebObserver.h>

static const char reply[] =
    "HTTP/1.0 200 OK\r\n"
    "Server: TargetRTS/D600\r\n"
    "Last-Modified: " __DATE__ " " __TIME__ " GMT\r\n"
    "Connection: close\r\n"
    "Content-Type: text/html\r\n"
    "\r\n"
    "<HTML><PRE>\n"
    "RoseRT C++ Target Run Time System\n"
    RT_VERSION_STRING "\n"
    "Copyright (c) 1999-" RT_VERSION_YEAR " Rational Software</PRE>\n"
    "<BR>\n"
    "This is for now just a static page. At some time later<BR>\n"
    "you will be able to click around and see the actor structure.\n"
    "</HTML>\n"
    ;

RTWebObserver::RTWebObserver( RTDebugger  * theDebugger,
			      RTTcpSocket * theSocket,
			      int           theObsId,
			      const char  * initBuf,
			      int           initLen )
    : RTObserver( theDebugger, theSocket, theObsId, initBuf, initLen )
{
    (void)sendData( reply, (int)sizeof( reply ) );
}
