/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMain.h>
#include <RTObject_class.h>
#include <RTWrapper.h>

RTWrapper::RTWrapper( const void * _data, const RTObject_class * _type )
    : handle( (Handle *)0 )
{
    RTFieldOffset allocSize;

    allocSize  = RTOffsetOf( Handle, data[ 0 ] );
    allocSize += (RTFieldOffset)sizeof( Handle );
    allocSize -= (RTFieldOffset)1;
    allocSize += _type->_size;

    handle = new Handle [ (unsigned)allocSize / sizeof( Handle ) ];

    handle->ref_count = 1;
    handle->type      = _type;

    _type->copy( handle->data, _data );
}

RTWrapper::RTWrapper( const RTWrapper & other )
#ifdef _lint
    : handle( (Handle *)0 )
#endif
{
    RTMain::lock();

    handle = other.handle;

    handle->ref_count += 1;

    RTMain::unlock();
}
