/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTDaemonInfo_h__
#define __RTDaemonInfo_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

struct RTActor_class;

class RTDaemonInfo
{
public:
    enum ActorInfoType
    {
	InfoActor,
	InfoPort,
	InfoState,
	InfoChain,
	InfoVariable
    };

    int                   daemonKind;
    int                   probeNr;
    char                * actorPath;
    int                   actorIndex;
    const RTActor_class * info;
    int                   actorDepth; // /=0, /ActorA:0=1, /ActorA:0/ActorB:0=2

    // used by actor daemons:
    int                   allRecurs;

    // used by port daemons:
    char                * portName;
    int                   portId;
    int                   portIndex;

    // used by state daemons:
    char                * stateStrTarget;
    int                   stateTarget;
    int                   stateDepth;

    // used by chain daemons:
    char                * chainStrOrigin;
    char                * chainStrTrans;
    int                   chainOrigin;
    int                   chainTrans;
    int                   chainPosition;

    // used by variable daemons:
    char                * variableName;

	     RTDaemonInfo( void );
    virtual  ~RTDaemonInfo( void );

    void     setInfo     (    const char * theActor );
    void     setInfoActor(    const char * theActor, int theAllRecurs );
    void     setInfoChain(    const char * theActor,
			      const char * theOrigin,
			      const char * theTrans,
			      int          thePos );
    void     setInfoPort (    const char * theActor, const char * thePort  );
    void     setInfoState(    const char * theActor, const char * theState );
    void     setInfoVariable( const char * theActor, const char * theVariable );

private:
    // unavailable methods
    RTDaemonInfo( const RTDaemonInfo & );
    RTDaemonInfo & operator=( const RTDaemonInfo & );
}; //lint !e1712

#endif // __RTDaemonInfo_h__
