/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTDiagStream_h__
#define __RTDiagStream_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class  RTDataObject;
class  RTMutex;
struct RTObject_class;
struct RTTimespec;

// It is safe to ignore the return value of these functions.
//lint -esym(534,RTDiagStream::lock)
//lint -esym(534,operator<<)
//lint -esym(534,RTDiagStream::unlock)
//lint -esym(534,RTDiagStream::write)

class RTDiagStream
{
public:
				RTDiagStream( void );
				~RTDiagStream( void );

    RTS_INLINE RTDiagStream   & lock( void );
	       RTDiagStream   & write( const char * );
#if OBJECT_ENCODE
	       RTDiagStream   & write( const void *, const RTObject_class * );
#endif
	       void             flush( void );
    RTS_INLINE RTDiagStream   & unlock( void );

private:
#if USE_THREADS
    RTMutex   * _mutex;
#endif

    // unavailable methods
    RTDiagStream( const RTDiagStream & );
    RTDiagStream & operator=( const RTDiagStream & );
};

RTS_INLINE RTDiagStream & operator<<( RTDiagStream &, const char * );
	   RTDiagStream & operator<<( RTDiagStream &, const char * const * );
	   RTDiagStream & operator<<( RTDiagStream &, const void * );
	   RTDiagStream & operator<<( RTDiagStream &, long );
	   RTDiagStream & operator<<( RTDiagStream &, unsigned long );

RTS_INLINE RTDiagStream & operator<<( RTDiagStream &, char );
RTS_INLINE RTDiagStream & operator<<( RTDiagStream &, unsigned char );
RTS_INLINE RTDiagStream & operator<<( RTDiagStream &, short );
RTS_INLINE RTDiagStream & operator<<( RTDiagStream &, unsigned short );
RTS_INLINE RTDiagStream & operator<<( RTDiagStream &, int );
RTS_INLINE RTDiagStream & operator<<( RTDiagStream &, unsigned );

#if RTS_INLINES
#include <RTDiagStream.inl>
#endif

#endif // __RTDiagStream_h__
