/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTPurgeFilter_h__
#define __RTPurgeFilter_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTQFilter_h__
#include <RTQFilter.h>
#endif

class RTController;
class RTMessage;
class RTProtocol;

class RTPurgeFilter : public RTQFilter
{
public:
    enum Options
    {
	All, Index, Signal, SignalIndex
    };

		    RTPurgeFilter( RTController *,
				   RTProtocol   *,
				   Options        options,
				   int            signal = 0,
				   int            index  = 0 );

    virtual         ~RTPurgeFilter( void );

    virtual int     select( RTMessage & );
    virtual void    accept( RTMessage & );

private:

    RTController * context;
    RTProtocol   * port;
    int            options;
    int            signal;
    int            index;

    // unavailable methods
    RTPurgeFilter & operator=( const RTPurgeFilter & );
    RTPurgeFilter( const RTPurgeFilter & );
}; //lint !e1712

#endif // __RTPurgeFilter_h__
