/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTRelayPort_h__
#define __RTRelayPort_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class  RTActor;
class  RTActorRef;
class  RTController;
struct RTBindingEnd;

class RTRelayPort
{
public:
    RTS_INLINE      RTRelayPort( void );
		    ~RTRelayPort( void );

protected:
    friend class RTActor;
    friend class RTActorRef;

    RTActorRef   ** _importers;

    void            init( int indirectUse );

    int             directUse( const RTActorRef * home, int id ) const;

    int             reserve( const RTActorRef * home,
			     int                id,
			     int                count,
			     int                size,
			     RTActorRef       * importer );

    int             followIn( RTBindingEnd & end,
			      RTActor      * owner,
			      int            id,
			      int            index,
			      int            size,
			      RTActorRef   * importer );

    int             followOut( RTBindingEnd & end,
			       RTActor      * owner,
			       int            id,
			       int            index,
			       int            size );

    void            unreserve( RTActor    * owner,
			       int          id,
			       int          size,
			       RTActorRef * importer ,RTController * initiator);

private:
    // unavailable methods
    RTRelayPort & operator=( const RTRelayPort & );
    RTRelayPort( const RTRelayPort & );
};

#if RTS_INLINES
#include <RTRelayPort.inl>
#endif

#endif // __RTRelayPort_h__
