/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTSpecialSignals_h__
#define __RTSpecialSignals_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

struct RTProtocolDescriptor;

enum RTSpecialSignals
{
    RTInitSignal = 1
  , RTStartSignal
  , RTStopSignal
  , RTDestroySignal         // actor or controller

  , RTInterruptSignal       // timer and I/O

  , RTTimeoutSignal         // timing service
  , RTPendingTimeoutSignal

  , RTAckSignal             // general (cross-thread) acknowledgement
  , RTWakeupSignal          // general (cross-thread) wake-up

  , RTProbeSignal           // actor probe attention, please
};

extern const RTProtocolDescriptor RTControl_Protocol_Class;
extern const RTProtocolDescriptor RTControl_Conjugate_Class;

#endif // __RTSpecialSignals_h__
