/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTMemoryUtil.h>
#include <RTMutex.h>
#include <RTNucleus.h>

RTMutex::RTMutex( void )
{
#ifndef NU_NO_ERROR_CHECKING
    RTMemoryUtil::memset( &semaphore, 0, (int)sizeof( semaphore ) );
#endif

    RTNucleus::Name name;

    RTNucleus::makeName( name, RTNucleus::Mutex, this );

    if( NU_Create_Semaphore( &semaphore, name, 1U, NU_PRIORITY ) != NU_SUCCESS )
	RTDiag::panic( "create(mutex)" );
}
