/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTNucleus.h>
#include <RTSyncObject.h>
#include <RTTimespec.h>

void RTSyncObject::timedwait( const RTTimespec & expireTime )
{
    long   delta;
    STATUS status;

    if( (delta = expireTime.ticksFromNow( RTNucleus::clock_period )) <= 0 )
    {
	// already at or past expiry time
    }
    else if( (status = NU_Obtain_Semaphore( &semaphore, delta )) == NU_SUCCESS )
    {
	// event was set
    }
    else if( status == NU_TIMEOUT )
    {
	// wait timed out
    }
    else
    {
	RTDiag::panic( "obtain(sync::timedwait)" );
    }
}
