/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebuggerInput.h>
#include <RTstdio.h>

#include <errno.h>
#include <ctype.h>

#define READ_BUFF_SZ 500

int RTDebuggerInput::nextChar( void )
{
    static bool   isEmpty = true;
    static char   rBuff[ READ_BUFF_SZ ];
    static char * wPos;
    static char * rPos;
    int           c;

    if( isEmpty ) for( wPos = rPos = rBuff; ; )
    {
	switch( c = cgetc() )
	{
	case '\r':
	case '\n':
	    cputc( '\r' );
	    cputc( '\n' );
	    c = '\n';
	    break;

	case '\t':
	    continue;

	case '\b':
	    if( wPos > rBuff )
	    {
		--wPos;
		cputc( '\b' );
		cputc( ' ' );
		cputc( '\b' );
	    }
	    continue;

	default:
	    if( iscntrl( c ) )
	    {
		cputc( '\r' );
		cputc( '\n' );
		c = EOF;
	    }
	    else if( isprint( c ) )
		cputc( c );
	    break;
	}

	*wPos++ = c;
	if( ( wPos == rBuff + READ_BUFF_SZ ) || c == EOF || c == '\n' )
	{
	    isEmpty = false;
	    break;
	}
    }

    c = *rPos++;

    if( rPos == wPos )
	isEmpty = true;

    return c;
}
