/********************************************************************/
/*Licensed Materials - Property of IBM                              */ 
/*Component IBM Rational ROSE_RT BUILD : TARGET_RTS                 */ 
/*Copyright IBM Corporation 1999, 2007. All Rights Reserved.      */ 
/*U.S. Government Users Restricted Rights -  Use, duplication or    */ 
/*disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.*/ 
/********************************************************************/

#include <RTDiag.h>
#include <RTTimespec.h>

#include <errno.h>
#include <time.h>

void RTTimespec::getclock( RTTimespec & ts )
{
    int      failures = 0;
    timespec now;

    while( clock_gettime( CLOCK_REALTIME, &now ) != 0 )
    {
	int error = errno;

	// Ten should be more than generous!
	if( ++failures <= 10 && ( error == EINTR || error == EINVAL ) )
	    continue;

	RTDiag::panic( "clock_gettime" );
    }

    ts.tv_sec  = now.tv_sec;
    ts.tv_nsec = now.tv_nsec;
}
